load site_coordinates0
load site_coordinates

L0=length(site_coordinates0);
L=length(site_coordinates);
 
%--------------------------------------------
%figure window where map and network is shown
%--------------------------------------------

load albania
load bulgaria
load greece
load italy
load turkey
load yugoslavia

p=get(0,'ScreenSize');
POS=[p(1)+0.05*p(3) p(2)+0.1*p(4) 0.9*p(3) 0.8*p(4)];
network_map=figure('NumberTitle','off','Name', ...
         'Fired brick networks','position',POS,'units','normalized', ...
         'resize','off','color','w');
   
hold on     
mapshow(albania)
mapshow(bulgaria)
mapshow(greece)
mapshow(italy)
mapshow(turkey)
mapshow(yugoslavia)

map=gca;
set(map,'xtick',[],'ytick',[],'xcolor','w','ycolor','w')
xl=get(map,'xlim');
yl=get(map,'ylim');
ratio=0.9*p(3)*(yl(2)-yl(1))/(0.8*p(4)*(xl(2)-xl(1)));
lp=0;
w=1-2*lp;
map_pos=[lp 0.5-ratio*w/2 w ratio*w];
set(map,'position',map_pos)
set(map,'color',[1 1 1])

network=axes('position',map_pos,'color','none','xlim',xl,'ylim',yl,'xtick',[],'ytick',[],'xcolor','w','ycolor','w');

network_component=axes('position',map_pos,'color','none','xlim',xl,'ylim',yl,'xtick',[],'ytick',[],'xcolor','w','ycolor','w');

linkaxes([map network network_component],'xy')

add_site=uicontrol(network_map,'style','pushbutton','units','normalized', ...
        'pos',[0.65 0.05 0.08 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Add site','callback','addsite','enable','on','interruptible','on','fonts',12);

delete_site=uicontrol(network_map,'style','pushbutton','units','normalized', ...
        'pos',[0.74 0.05 0.08 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Delete site','callback','deletesite','enable','on','interruptible','on','fonts',12);

save_sites=uicontrol(network_map,'style','pushbutton','units','normalized', ...
        'pos',[0.83 0.05 0.08 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Save','callback','savesites','enable','on','interruptible','on','fonts',12);

numbert=uicontrol(network_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.05 0.9 0.10 0.05],'backgroundc','w','string','Number of sites:','fonts',12);    
    
number=uicontrol(network_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.16 0.9 0.1 0.05],'backgroundc','w','string',num2str(L),'fonts',12);

%--------------------------------------------
%The existing sites are marked on the map
%--------------------------------------------

for k=1:L0
        line('color','r','marker','.','markersize',20, ...
            'xdata',site_coordinates(k,1),'ydata',site_coordinates(k,2));
end
if L>L0
    for k=L0+1:L
            line('color','k','marker','.','markersize',20, ...
                'xdata',site_coordinates(k,1),'ydata',site_coordinates(k,2));
    end
end
