% This program allows the user to construct and analyse phenomenological
% networks describing relations between findings of burned bricks in the
% mediterranean world in pre-roman and early roman times.

% To run the program, type 'cd X', where X should be replaced by the
% pathway to the folder in which the relevant MATLAB-files are stored.
% In Per's computer,
% X=\\staff.ht.lu.se\matf-pos$\Documents\tegel\matlabfiler.
% Press return, then type "Brick_networks" and press return again.

% To find detailed instructions how to use the program, click the
% help-button in the command window of the program, appearing automatically
% when the program is run.

% Executing the file "M_test.m" creates the database-matrix M, which is the
% fundamental data source used by the program. The structure and content of
% M corresponds exactly to the excel data base file "excel brick database
% XXXXXX.xlsx" (where XXXXXX is a date). In this file,
% explanations of rows, columns and matrix elements are given.
%--------------------------------------------------------------------------
clear
%Matrix
Matrix_truepositions
sites
descriptions

% Questionable contexts are excluded in the final data_base matrix M, and
% has to be erased from the matrix M_raw read from the file Matrix.m.
%--------------------------------------------------------------------------
A_raw=length(M_raw(:,1));
j=0;
for k=1:A_raw
    if M_raw(k,2)==0
    %if M_raw(k,2)==0 && M_raw(k,8)==3
        j=j+1;
        M(j,:)=M_raw(k,:);
        site_names(j)=site_names_raw(k);
        Descriptions(j)=Descriptions_raw(k);
    end
end

A=length(M(:,1));
B=length(M(1,:))-1;

edgebin_length=10000;
%edgebin_length=500000;
distance_dist

% A map of the mediterranean is created, together with other windows used
% to handle the program.
% -------------------------------------------------------------------------
brick_map