% Exploration of the edge length distribution
% sd(j) is the number of possible edges within a given length bin j.
% d(j) is the number of realized edges within this length bin j for the
% chosen similarity network.
% ad(j)is the ratio of the possible edges at length j that are realized. if
% the attributes of the objects were randomly distributed among the sites,
% this ratio would be independent of edge length j.
% cad is the cumulative distribution of ad.

clear ad
clear d
clear cad

d=nddd*length(ndd);
sd=ddd*length(dd);
L=length(d);
for j=1:L
    if sd(j)>0
        ad(j)=d(j)/sd(j);
    else
        ad(j)=0;
    end
end

for j=1:L
    cad(j)=sum(ad(j:L));
end