printed=zeros(A,1);
N=zeros(A,A);
s='empty network';

%--------------------------------------------
%figure window where map and network is shown
%--------------------------------------------

load albania
load bulgaria
load greece
load italy
load turkey
load yugoslavia

p=get(0,'ScreenSize');
POS=[p(1)+0.05*p(3) p(2)+0.1*p(4) 0.9*p(3) 0.8*p(4)];
network_map=figure('NumberTitle','off','Name', ...
         'Fired brick networks','position',POS,'units','normalized', ...
         'resize','off','color','w');
   
hold on     
mapshow(albania)
mapshow(bulgaria)
mapshow(greece)
mapshow(italy)
mapshow(turkey)
mapshow(yugoslavia)

map=gca;
set(map,'xtick',[],'ytick',[],'xcolor','w','ycolor','w')
xl=get(map,'xlim');
yl=get(map,'ylim');
ratio=0.9*p(3)*(yl(2)-yl(1))/(0.8*p(4)*(xl(2)-xl(1)));
lp=0;
w=1-2*lp;
map_pos=[lp 0.5-ratio*w/2 w ratio*w];
set(map,'position',map_pos)
set(map,'color',[1 1 1])

network=axes('position',map_pos,'color','none','xlim',xl,'ylim',yl,'xtick',[],'ytick',[],'xcolor','w','ycolor','w');

network_specification=uicontrol(network_map,'style','text','units','normalized', ...
        'pos',[0.03 0.91 0.40 0.05],'backgroundcolor','w','fonts',12, ...
	    'HorizontalAlignment','left','foregroundcolor','k','string','');

network_component=axes('position',map_pos,'color','none','xlim',xl,'ylim',yl,'xtick',[],'ytick',[],'xcolor','w','ycolor','w');

linkaxes([map network network_component],'xy')

% ----------------------------------------------------------------
% Window where network conditions are specified by the user
% ----------------------------------------------------------------

p=get(0,'ScreenSize');
POS=[p(1)+0.01*p(3) p(2)+0.1*p(4) 0.6*p(3) 0.15*p(4)];
spec_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Network commands','position',POS,'units','normalized', ...
         'resize','off','color','w');

spec_axes=gca;
set(spec_axes,'xtick',[],'ytick',[],'xcolor','w','ycolor','w')
xl=get(spec_axes,'xlim');
yl=get(spec_axes,'ylim');
ratio=0.9*p(3)*(yl(2)-yl(1))/(0.8*p(4)*(xl(2)-xl(1)));
lp=0;
w=1-2*lp;
set(spec_axes,'position',[lp 0.5-ratio*w/2 w ratio*w])
set(spec_axes,'color',[1 1 1])


specify_text=uicontrol(spec_fig,'style','text','units','normalized', ...
        'pos',[0.03 0.6 0.20 0.22],'backgroundcolor','w','fonts',12, ...
	    'HorizontalAlignment','left','foregroundcolor','k','string','Network specification');	

spec_field=uicontrol(spec_fig,'style','edit','units','normalized', ...
      'pos',[0.24 0.6 0.36 0.2],'backgroundcolor','w','fonts',12, ...
      'callback','s_old=s;s=get(spec_field,''string'');read_specification_string');
  
analyse_text=uicontrol(spec_fig,'style','text','units','normalized', ...
        'pos',[0.03 0.2 0.20 0.22],'backgroundcolor','w','fonts',12, ...
	    'HorizontalAlignment','left','foregroundcolor','k','string','Network analysis');	

analyse_field=uicontrol(spec_fig,'style','edit','units','normalized', ...
      'pos',[0.24 0.2 0.36 0.2],'backgroundcolor','w','fonts',12, ...
      'enable','off','callback','as=get(analyse_field,''string'');read_analysis_string');
  
see_edges=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.65 0.63 0.18 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Hide edges','callback','view_edges','enable','off','interruptible','on','fonts',12);	
  
view_name=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.65 0.37 0.18 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','View name & ID','callback','print_site_name','enable','off','interruptible','on','fonts',12);	

hide_name=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
      'pos',[0.65 0.17 0.18 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Hide name','callback','delete_site_name','enable','off','interruptible','on','fonts',12');
    
movie_button=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.87 0.6 0.1 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Movie','callback','see_movie','interruptible','on','fonts',12);

help_button=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.87 0.2 0.1 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Help','callback','help_figure','interruptible','on','fonts',12);

% -------------------------------------------------------------------------
% Window where network properties are shown
% -------------------------------------------------------------------------
    
p=get(0,'ScreenSize');
POS=[p(1)+0.7*p(3) p(2)+0.1*p(4) 0.29*p(3) 0.83*p(4)];
res_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Network properties','position',POS,'units','normalized', ...
         'resize','off','color','w');
     
component_axes=axes('position',[0.13 0.75 0.83 0.2],'units','normalized','visible','off');
    
r3t=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.64 0.65 0.03],'backgroundc','w','string','Clustering coefficient','fonts',10);
    
r7t=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.61 0.65 0.03],'backgroundc','w','string','Characteristic path length','fonts',10);
    
r8t=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.58 0.65 0.03],'backgroundc','w','string','Diameter','fonts',10);

degree_axes=axes('position',[0.13 0.36 0.83 0.18],'units','normalized','visible','off');

% tail_axes=axes('position',[0.13 0.06 0.35 0.15],'units','normalized','visible','off');

% length_axes=axes('position',[0.61 0.06 0.35 0.15],'units','normalized','visible','off');

edge_axes=axes('position',[0.13 0.06 0.83 0.2],'units','normalized','visible','off');

    
    
% -------------------------------------------------------------------------
% Window where context information is shown, given the ID-number
% -------------------------------------------------------------------------

p=get(0,'ScreenSize');
POS=[p(1)+0.01*p(3) p(2)+0.73*p(4) 0.6*p(3) 0.20*p(4)];
info_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Context information','position',POS,'units','normalized', ...
         'resize','off','color','w');
     
ID_printed=uicontrol(info_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.84 0.97 0.12],'backgroundcolor','w','fonts',12, ...
      'string','','horizontalalignment','left');

ID_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.03 0.70 0.11 0.12],'backgroundc','w','string','Choose ID:','fonts',12);
    
ID_field=uicontrol(info_fig,'style','edit','units','normalized', ...
      'pos',[0.14 0.70 0.04 0.12],'backgroundcolor','w','fonts',12, ...
      'callback','id_string=get(ID_field,''string'');print_info');
  
descriptions_text=uicontrol(info_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.02 0.97 0.11],'backgroundcolor','w','fonts',11, ...
      'string','','horizontalalignment','left');
  

time_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.03 0.54 0.12 0.11],'backgroundc','w','string','Time (B.C.)','fonts',10,'fontangle','oblique');
   
phase_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.03 0.44 0.12 0.11],'backgroundc','w','string','Phase (B.C.)','fonts',10,'fontangle','oblique');
 
structural_use_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.03 0.34 0.12 0.11],'backgroundc','w','string','Structural use','fonts',10,'fontangle','oblique');
    
context_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.03 0.24 0.12 0.11],'backgroundc','w','string','Context','fonts',10,'fontangle','oblique');
    
    
time_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.15 0.54 0.14 0.11],'backgroundc','w','string','','fonts',10);
   
phase_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.15 0.44 0.14 0.11],'backgroundc','w','string','','fonts',10);
 
structural_use_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.15 0.34 0.14 0.11],'backgroundc','w','string','','fonts',10);
    
context_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.15 0.24 0.14 0.11],'backgroundc','w','string','','fonts',10);
    
    
function1_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.30 0.54 0.12 0.11],'backgroundc','w','string','Function 1','fonts',10,'fontangle','oblique');
   
function2_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.30 0.44 0.12 0.11],'backgroundc','w','string','Function 2','fonts',10,'fontangle','oblique');
 
structure_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.30 0.24 0.12 0.11],'backgroundc','w','string','Structure','fonts',10,'fontangle','oblique');
    
binding_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.30 0.34 0.12 0.11],'backgroundc','w','string','Binding','fonts',10,'fontangle','oblique');
    
    
function1_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.42 0.54 0.14 0.11],'backgroundc','w','string','','fonts',10);
   
function2_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.42 0.44 0.14 0.11],'backgroundc','w','string','','fonts',10);
 
structure_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.42 0.15 0.14 0.2],'backgroundc','w','string','','fonts',10);
    
binding_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.42 0.34 0.14 0.11],'backgroundc','w','string','','fonts',10);
    
    
shape1_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.57 0.54 0.12 0.11],'backgroundc','w','string','Shape 1','fonts',10,'fontangle','oblique');
   
shape2_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.57 0.44 0.12 0.11],'backgroundc','w','string','Shape 2','fonts',10,'fontangle','oblique');
 
size_category1_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.57 0.34 0.12 0.11],'backgroundc','w','string','Size category 1','fonts',10,'fontangle','oblique');
    
size_category2_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.57 0.24 0.12 0.11],'backgroundc','w','string','Size category 2','fonts',10,'fontangle','oblique');
    
thickness_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.57 0.14 0.12 0.11],'backgroundc','w','string','Thickness (cm)','fonts',10,'fontangle','oblique');
    
    
shape1_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.70 0.54 0.14 0.11],'backgroundc','w','string','','fonts',10);
   
shape2_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.70 0.44 0.14 0.11],'backgroundc','w','string','','fonts',10);
 
size_category1_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.70 0.34 0.14 0.11],'backgroundc','w','string','','fonts',10);
    
size_category2_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.70 0.24 0.14 0.11],'backgroundc','w','string','','fonts',10);
    
thickness_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.70 0.14 0.14 0.11],'backgroundc','w','string','','fonts',10);
    
    
poorly_fired_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.84 0.54 0.12 0.11],'backgroundc','w','string','Poorly fired','fonts',10,'fontangle','oblique');
   
tile_bricks_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.84 0.44 0.12 0.11],'backgroundc','w','string','Tile bricks','fonts',10,'fontangle','oblique');
 
plaster_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.84 0.34 0.12 0.11],'backgroundc','w','string','Plaster','fonts',10,'fontangle','oblique');
    
mud_bricks_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.84 0.24 0.12 0.11],'backgroundc','w','string','Mud bricks','fonts',10,'fontangle','oblique');
    
stamp_text=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.84 0.14 0.12 0.11],'backgroundc','w','string','Stamp','fonts',10,'fontangle','oblique');
    
    
poorly_fired_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.96 0.54 0.12 0.11],'backgroundc','w','string','','fonts',10);
   
tile_bricks_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.96 0.44 0.12 0.11],'backgroundc','w','string','','fonts',10);
 
plaster_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.96 0.34 0.12 0.11],'backgroundc','w','string','','fonts',10);
    
mud_bricks_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.96 0.24 0.12 0.11],'backgroundc','w','string','','fonts',10);
    
stamp_response=uicontrol(info_fig,'style','text','units','normalized','horizontalalignment','left','visible','on', ...
        'pos',[0.96 0.14 0.12 0.11],'backgroundc','w','string','','fonts',10);
