%--------------------------------------------------------------------------
%Calculates the median edge length "elength" for a given network (matrix N)
%if the variable do_edgelengths is set to one, and calculates the length
%"vlength" of the resultant diffusion vector (x,y) if do_directions is set
%to one. The network N must first be created within the program
%Brick_networks. Note that in the mode do_edgelengths=1, you must choose
%whether to include edgelenghts of length zero (see line 38).
%--------------------------------------------------------------------------

do_directions=0;
do_edgelengths=1;
clear edgelengths
clear sorted_lengths
clear vx
clear vy

if do_directions==1
    x=0;
    y=0;
    count=0;
    for j=1:A
        for k=1:j-1
            if trueangle(j,k)==1 && N(j,k)==1
                count=count+1;
                vl=sqrt(x_component(j,k)^2+y_component(j,k)^2);
                vx(count)=x_component(j,k)/vl;
                vy(count)=y_component(j,k)/vl;
                x=x+vx(count);
                y=y+vy(count);
            end
        end
    end
    x/count
    y/count
    vlength=sqrt(x^2+y^2)/count
    count
   
end
    
if do_edgelengths==1
    count=0;
    for j=1:A
        for k=1:j-1
            %Choose whether to exclude zero edge lengths (the following
            %if-sentence) or not (the second following if-sentence).
            if N(j,k)==1 && sqrt((M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2)>0
            %if N(j,k)==1
                count=count+1;
                edgelengths(count)=sqrt((M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2);
            end
        end
    end
    sorted_lengths=sort(edgelengths);
    L=length(edgelengths);
    if mod(L,2)==0
        elength=(sorted_lengths(L/2)+sorted_lengths(L/2+1))/2;
    else
        elength=sorted_lengths(floor(L/2)+1);
    end
    elength/1000
end