p=get(0,'ScreenSize');
POS=[p(1)+0.4*p(3) p(2)+0.1*p(4) 0.59*p(3) 0.83*p(4)];
help_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'How networks are specified','position',POS,'units','normalized', ...
         'resize','off','color','w');
     
textaxes=gca;
set(textaxes,'position',[0 0 1 1],'xtick',[],'ytick',[],'xcolor','w','ycolor','w')

helptext= ...
['---------------------------------------------------------------------------------------';
 'NETWORK INSTRUCTIONS                                                                   ';
 '---------------------------------------------------------------------------------------';
 '                                                                                       ';
 'VS         A map with all sites is shown. Do not combine with other instructions.      ';
 '                                                                                       ';
 'Variable instructions                                                                  ';
 '---------------------------------------------------------------------------------------';
 'X          Pairs of nodes with the same value of variable X are connected by an edge.  ';
 '(X=3)      Pairs of nodes for which X=3 are connected by an edge.                      ';
 '(A list of all variables and their possible values is given below.)                    ';
 '                                                                                       ';
 'Special cases: variables with different syntax                                         ';
 '---------------------------------------------------------------------------------------';
 '(D<500)    Pairs of nodes within 500 km from each other are connected by an edge.      ';
 '           Instructions "D" or "D=Y" are not defined. In the command (D<Y), Y is an    ';
 '           integer in the interval (0,9999).                                           ';
 'N          Time interval N=(T_min, T_max). Pairs of nodes for which the time intervals ';
 '           overlap are connected by an edge.                                           ';
 'N=(230,50) Pairs of nodes with time intervals that overlap the interval (230,50) are   ';
 '           connected by an edge.                                                       ';
 'O          Pairs of nodes with the same time phase are connected by an edge.           ';
 'O=(300,250)Pairs of nodes with time phases in the interval (300,250) are connected by  ';
 '           an edge.                                                                    ';
 'P          Interval of brick thicknesses (P_min, P_max). Pairs of nodes for which the  ';
 '           thicknesses overlap are connected by an edge.                               ';
 'P=(2,5)    Pairs of nodes with thickness intervals that overlap the interval (2,5) are ';
 '           connected by an edge.                                                       ';
 '                                                                                       ';
 'Other instructions                                                                     ';
 '---------------------------------------------------------------------------------------';
 '(TW=5)     Pairs of nodes for which the time windows (T-5, T+5) overlap are connected  ';
 '           by an edge, where T=(T_min + T_max)/2.                                      ';
 '(dO<=25)   Pairs of nodes with phase difference less than or equal to 25 years are     ';
 '           connected by an edge.                                                       ';
 '(dO=25)    Pairs of nodes with phase difference equal to 25 years are connected by an  ';
 '           edge.                                                                       ';
 '(-S153)    Node 153 is not connected by edges to any other nodes.                      ';
 '(CO=4)     Pairs of nodes for which values of four or more variables coincide, are     ';
 '           connected by an edge. The distance variable D is not considered.            ';
 '(CO=4/FG)  Pairs of nodes for which four or more variables have the same value are     ';
 '           connected by an edge, if this condition is fulfilled even if variables F and';
 '           G are disregarded.                                                          ';
 '                                                                                       ';
 'The instructions can be combined with the logical operators                            ';
 '---------------------------------------------------------------------------------------';
 '&          and                                                                         ';
 '%          or                                                                          ';
 '                                                                                       ';
 'Examples                                                                               ';
 '---------------------------------------------------------------------------------------';
 '(B%C)&E         Pairs of nodes for which variables B or C have the same value, and for ';
 '                which E has the same value, are connected by an edge. Observe that     ';
 '                B%(C&E) is another instruction, and that B%C&E is logically            ';
 '                indeterminate.                                                         ';
 'B&(C=3)&(-S153) Pairs of nodes which have the same value of B, and the same value      ';
 '                3 of variable C, are connected by an edge. No edges are drawn to or    ';
 '                from the node with ID-number 153.                                      ';
 '(CO=4/B)&C      Pairs of nodes for which four or more variables have the same value,   ';
 '                even if C is discarded, are connected by an edge. In addition, C must  ';
 '                have the same value for both nodes.                                    ';
 'N&(N=350,250)   Pairs of nodes with overlapping time intervals, and time intervals that';
 '                overlap with the period 350-250 B.C. are connected by an edge.         ';
 '                                                                                       ';
 'Analysis of a given network (Use the lower command window)                             ';
 '---------------------------------------------------------------------------------------';
 'Degree>20     Nodes with degree larger than 20 are marked in red. Their ID-numbers are ';
 '              shown.                                                                   ';
 'Diff1         Displays the difference between the present network and the previous one ';
 '              (in blue). That is, if and only if a given edge exists in the present    ';
 '              network, but not in the previous one, then a blue edge is shown. Nodes   ';
 '              are coloured blue if and only if they are connected to other nodes in the';
 '              present network, but are isolated in the previous network. The ID:s of   ';
 '              the "new" blue nodes are displayed in the MATLAB command window.         ';
 'Diff2         Displays the difference the other way around - the present and previous  ';
 '              networks change roles.                                                   ';
 'Paths(23,148) The shortest path(s) between nodes 23 and 148 are marked in red. The     ';
 '              paths are displayed in matrix form in the MATLAB command window; each    ';
 '              column represents a distinct shortest path, and each entry in the column ';
 '              is a node that is passed in that particular path.                        ';
 'Component3    The third largest component is shown in blue. The ID:s of the member     ';
 '              nodes are displayed in the MATLAB command window.                        ';
 '                                                                                       ';
 'Analysis of a given network component                                                  ';
 '---------------------------------------------------------------------------------------';
 'Hubs       The node (or nodes) with largest degree within a given component is marked  ';
 '           in red. The degree and the ID-number(s) are shown.                          ';
 'B_Centers  The betweenness center (or centers) of the component is marked in yellow.   ';
 '           The betweenness centrality of all nodes in the component are displayed in   ';
 '           MATLAB command window; the first entry in each row is the node ID, the      ';
 '           second entry is its betweenness centrality.                                 ';
 'C_Centers  The closeness center (or centers) of the component is marked in green.      ';
 '           The closeness centrality of all nodes in the component are displayed in     ';
 '           MATLAB command window; the first entry in each row is the node ID, the      ';
 '           second entry is its closeness centrality.                                   ';
 '                                                                                       ';
 'Variables                                                                              ';
 '---------------------------------------------------------------------------------------';
 'A  Binding                                                                             ';
 '   1 =Clay mortar                                                                      ';
 '   2 =Mortar                                                                           ';
 '   3 =No mortar                                                                        ';
 '   4 =Timber bindings                                                                  '; 
 'B  Combined with mud brick                                                             '; 
 '   0 =No                                                                               ';
 '   1 =Yes                                                                              ';
 'C  Context                                                                             ';
 '   1 =(Void)                                                                           ';
 '   2 =Domestic                                                                         ';
 '   3 =Manufacture                                                                      ';
 '   4 =Military                                                                         ';
 '   5 =Public                                                                           ';
 '   6 =Sacred                                                                           ';
 '   7 =Sepulchral                                                                       ';
 'D  Distance between nodes/brick contexts                                               ';
 'E  Function                                                                            ';
 '   1 =Arch                                                                             ';
 '   2 =Basin                                                                            ';
 '   3 =Barrell vault                                                                    ';
 '   4 =Bench                                                                            ';
 '   5 =Bonding courses                                                                  ';
 '   6 =Cist                                                                             ';
 '   7 =Column                                                                           ';
 '   8 =Courtyard                                                                        ';
 '   9 =Cover                                                                            ';
 '  10 =Door frame                                                                       ';
 '  11 =Floor                                                                            ';
 '  12 =Foundation                                                                       ';
 '  13 =Half-column                                                                      ';
 '  14 =Hypocaust                                                                        ';
 '  15 =Inner wall                                                                       ';
 '  16 =Niche cover                                                                      ';
 '  17 =Pillar                                                                           ';
 '  18 =Pillar base                                                                      ';
 '  19 =Quoin                                                                            ';
 '  20 =Street                                                                           ';
 '  21 =Terrace wall                                                                     ';
 '  22 =Underground wall                                                                 ';
 '  23 =Upper wall                                                                       ';
 '  24 =Wall                                                                             ';
 '  25 =Wall socle                                                                       ';
 '  26 =Water channel                                                                    ';
 '  27 =Furnace wall                                                                     '; 
 'F  Plaster                                                                             ';
 '   1 =Yes                                                                              '; 
 'G  Poorly fired bricks                                                                 ';
 '   0 =No                                                                               ';
 '   1 =Yes                                                                              ';
 'H  Shape                                                                               '; 
 '   1 =Circle sectors                                                                   ';
 '   2 =Circular                                                                         ';
 '   3 =Curved                                                                           ';
 '   4 =Grooved                                                                          ';
 '   5 =Imbrex                                                                           ';
 '   6 =Pierced circular                                                                 ';
 '   7 =Rectangular                                                                      ';
 '   8 =Semicircular                                                                     ';
 '   9 =Square                                                                           ';
 '  10 =Tegula                                                                           ';
 '  11 =Triangular                                                                       ';
 '  12 =Voussoir                                                                         '; 
 'I  Size category                                                                       ';
 '   1 =Lydion                                                                           ';
 '   2 =Pentadoron                                                                       ';
 '   3 =Sesquipedalis                                                                    ';
 '   4 =tetradoron                                                                       ';
 'J  Stamp                                                                               '; 
 '   1 =Yes                                                                              ';
 'K  Structural use                                                                      ';
 '   1 =Casing                                                                           ';
 '   2 =Masonry                                                                          ';
 '   3 =Pavement                                                                         ';
 'L  Structure                                                                           '; 
 '   1 =Brick-faced concrete                                                             ';
 '   2 =Imbrices and mud                                                                 ';
 '   3 =Interlaced brickwork                                                             ';
 '   4 =One-stone brickwork                                                              ';
 '   5 =Mixed materials                                                                  ';
 '   6 =Solid brickwork                                                                  ';
 'M  Tile bricks                                                                         ';
 '   0 =No                                                                               '; 
 '   1 =Yes                                                                              ';
 'N  Time interval within which the context is supposed to appear                        ';
 '   Pair of positive integers, e.g. (325,290)                                           ';
 'O  Time phase in which the context is supposed to appear                               ';
 '   Positive integer in steps of 25: ..., 325, 300, 275, ..., 25                        ';
 'P  Thickness. Pair of integers (2,5). Interval of occurring brick thicknesses (cm).    ';
 '                                                                                       ';
 'Notes                                                                                  ';
 '---------------------------------------------------------------------------------------';
 'In some places, bricks with more than one shape and size have been found. This means   ';
 'that for these contexts, more than one value is assigned to variables H and I. The same';
 'goes for variable E (function). The result of the commands E, H and I is then that an  ';
 'edge is drawn between pairs of nodes for which the same value of the relevant variable ';
 'occurs, even if there are also values that differ.                                     ';
 '                                                                                       ';
 'All information about the network is encoded in the matrix N, where N(j,k)=1 if node   ';
 'j is connected to node k, and N(j,k)=0 otherwise. N can be studied in Matlabs command ';
 'window. The context ID-number that correspond to nodes j and k are found in the matrix ';
 'M, which contains the database in Matlab format. The first column of M contains the ID-';
 'number: ID(j)=M(j,1).                                                                  ';
 '                                                                                       ';
 'All variables can take the value -1, menaing lack of information. Two contexts with a  ';
 'given variable having value -1 are NOT considered to share a property, and no edges are';
 'drawn.                                                                                 '];


inserttext=uicontrol('style','edit','units','normalized','pos',[0 0 1 1], ...
    'horizontalalignment','left','FontName','FixedWidth','fontsize',10, ...
    'backgroundcolor',[1 1 1],'max',30,'string',helptext);