%--------------------------------------------------------------------------
%Structural analysis of networks ranomized databases (see explanation
%below), to be compared with the structure of the real network, given the
%same network instruction string ss.
%--------------------------------------------------------------------------

q_max=2000;

size_truev=[9478	9460	8985	7138	4635	2594	1508	925	516	206	83	47	8	1];
clustering_truev=[0.652	0.651	0.63	0.579	0.53	0.549	0.634	0.679	0.653	0.698	0.85	0.773	0.6	0];
pathlength_truev=[1.63	1.63	1.65	1.74	1.92	2.38	3.04	3.53	2.14	2.54	1.56	1.71	1.33	1];
diameter_truev=[4	4	4	5	5	6	7	10	6	8	4	4	2	1];
maxdegree_truev=[215	215	209	196	157	83	53	40	31	16	13	10	3	1];
meandegree_truev=[85.8	85.6	81.3	64.6	42.7	25.1	16.2	12.9	9.92	6.06	5.35	4.7	2	1];
vardegree_truev=[38.6	38.5	36.5	32	25.7	18.4	14	11.6	8.68	5.17	4.1	3.01	0.756	0];
firstcomp_truev=[221	221	221	221	217	207	181	130	45	33	14	12	4	2];
secondcomp_truev=[1	1	1	1	1	1	3	3	43	25	11	8	4	1];
numbercomp_truev=[1	1	1	1	1	1	3	7	8	7	5	2	2	1];


Matrix_truepos

% Questionable contexts are excluded in the final data_base matrix M, and
% has to be erased from the matrix M_raw read from the file M_test2.m.
%--------------------------------------------------------------------------
A_raw=length(M_raw(:,1));
j=0;
for k=1:A_raw
    if M_raw(k,2)==0
        j=j+1;
        M(j,:)=M_raw(k,:);
    end
end
A=length(M(:,1));
B=length(M(1,:))-1;



for CO=1:14
size_true=size_truev(CO);
clustering_true=clustering_truev(CO);
pathlength_true=pathlength_truev(CO);
diameter_true=diameter_truev(CO);
maxdegree_true=maxdegree_truev(CO);
meandegree_true=meandegree_truev(CO);
vardegree_true=vardegree_truev(CO);
firstcomp_true=firstcomp_truev(CO);
secondcomp_true=secondcomp_truev(CO);
numbercomp_true=numbercomp_truev(CO);
    
size=0;
extreme_size=0;
p_size=0;
sorted_size=0;

clustering=0;
extreme_clustering=0;
p_clustering=0;
sorted_clustering=0;

pathlength=0;
extreme_pathlength=0;
p_pathlength=0;
sorted_pathlength=0;

diameter=0;
extreme_diameter=0;
p_diameter=0;
sorted_diameter=0;

diameter=0;
extreme_diameter=0;
p_diameter=0;
sorted_diameter=0;

maxdegree=0;
extreme_maxdegree=0;
p_maxdegree=0;
sorted_maxdegree=0;

meandegree=0;
extreme_meandegree=0;
p_meandegree=0;
sorted_meandegree=0;

vardegree=0;
extreme_vardegree=0;
p_vardegree=0;
sorted_vardegree=0;

firstcomp=0;
extreme_firstcomp=0;
p_firstcomp=0;
sorted_firstcomp=0;

secondcomp=0;
extreme_secondcomp=0;
p_secondcomp=0;
sorted_secondcomp=0;

numbercomp=0;
extreme_numbercomp=0;
p_numbercomp=0;
sorted_numbercomp=0;

M_old=M;
for q=1:q_max
    M=M_old;
   
    %----------------------------------------------------------------------
    %A database is created where existing variable values are redistributed
    %randomly among the contexts. Dependent variables are kept together in
    %the randomization.
    %----------------------------------------------------------------------
    
    rpos=M(:,3:4);
    for k=1:A
        j=1+floor(rand*(A-k+1));
        M(k,3:4)=rpos(j,:);
        rpos_old=rpos;
        rpos(1:j-1,:)=rpos_old(1:j-1,:);
        rpos(j:A-k,:)=rpos_old(j+1:A-k+1,:);
    end
    
    % Structural use and function shall be kept together
        % -----------------------------------------------------------------
        structurefunction(:,1)=M_old(:,8);
        structurefunction(:,2:3)=M_old(:,16:17);
        structurefunction(:,4)=[1:A];
        remember_column=zeros(A,1);
        for k=1:A
            j=1+floor(rand*(A-k+1));
            l=structurefunction(j,4);
            if M_old(l,16)==7 || M_old(l,17)==7
                remember_column(k)=l;
            end
            M(k,8)=structurefunction(j,1);
            M(k,16:17)=structurefunction(j,2:3);
            structurefunction_old=structurefunction;
            structurefunction(1:j-1,:)=structurefunction_old(1:j-1,:);
            structurefunction(j:A-k,:)=structurefunction_old(j+1:A-k+1,:);
        end
        
        shape1(:,1)=M_old(:,11);
        shape1(:,2)=[1:A];
        remember_rectangular1=zeros(A,1);
        remember_square1=zeros(A,1);
        for k=1:A
            if remember_column(k)>0
                j=remember_column(k);
                M(k,11)=M_old(j,11);
                if M_old(j,11)==7
                    remember_rectangular1(k)=j;
                end
                if M_old(j,11)==9
                    remember_square1(k)=j;
                end
            end
        end
        m=0;
        for l=A:-1:1
            if M_old(l,16)==7 || M_old(l,17)==7
                m=m+1;
                if l<A
                    shape1(l:A-m,:)=shape1(l+1:A-m+1,:);
                end
            end
        end
        n=0;
        for k=1:A
            if remember_column(k)==0
                n=n+1;
                j=1+floor(rand*(A-m-n+1));
                l=shape1(j,2);
                if M_old(l,11)==7
                    remember_rectangular1(k)=l;
                end
                if M_old(l,11)==9
                    remember_square1(k)=l;
                end
                M(k,11)=shape1(j,1);
                shape1_old=shape1;
                shape1(1:j-1,:)=shape1_old(1:j-1,:);
                shape1(j:A-m-n,:)=shape1_old(j+1:A-m-n+1,:);
            end
        end
        
        shape2(:,1)=M_old(:,12);
        shape2(:,2)=[1:A];
        remember_rectangular2=zeros(A,1);
        remember_square2=zeros(A,1);
        for k=1:A
            if remember_column(k)>0
                j=remember_column(k);
                M(k,12)=M_old(j,12);
                if M_old(j,12)==7
                    remember_rectangular2(k)=j;
                end
                if M_old(j,12)==9
                    remember_square2(k)=j;
                end
            end
        end
        m=0;
        for l=A:-1:1
            if M_old(l,16)==7 || M_old(l,17)==7
                m=m+1;
                if l<A
                    shape2(l:A-m,:)=shape2(l+1:A-m+1,:);
                end
            end
        end
        n=0;
        for k=1:A
            if remember_column(k)==0
                n=n+1;
                j=1+floor(rand*(A-m-n+1));
                l=shape2(j,2);
                if M_old(l,12)==7
                    remember_rectangular2(k)=l;
                end
                if M_old(l,12)==9
                    remember_square2(k)=l;
                end
                M(k,12)=shape2(j,1);
                shape2_old=shape2;
                shape2(1:j-1,:)=shape2_old(1:j-1,:);
                shape2(j:A-m-n,:)=shape2_old(j+1:A-m-n+1,:);
            end
        end
        
        size1(:,1)=M_old(:,13);
        size1(:,2)=[1:A];
        for k=1:A
            if remember_rectangular1(k)>0
                j=remember_rectangular1(k);
                M(k,13)=M_old(j,13);
            end
            if remember_square1(k)>0
                j=remember_square1(k);
                M(k,13)=M_old(j,13);
            end
        end
        m=0;
        for l=A:-1:1
            if M_old(l,11)==7 || M_old(l,11)==9
                m=m+1;
                if l<A
                    size1(l:A-m,:)=size1(l+1:A-m+1,:);
                end
            end
        end
        n=0;
        for k=1:A
            if remember_rectangular1(k)==0 && remember_square1(k)==0
                n=n+1;
                j=1+floor(rand*(A-m-n+1));
                M(k,13)=size1(j,1);
                size1_old=size1;
                size1(1:j-1,:)=size1_old(1:j-1,:);
                size1(j:A-m-n,:)=size1_old(j+1:A-m-n+1,:);
            end
        end
        
        size2(:,1)=M_old(:,14);
        size2(:,2)=[1:A];
        for k=1:A
            if remember_rectangular2(k)>0
                j=remember_rectangular2(k);
                M(k,14)=M_old(j,14);
            end
            if remember_square2(k)>0
                j=remember_square2(k);
                M(k,14)=M_old(j,14);
            end
        end
        m=0;
        for l=A:-1:1
            if M_old(l,12)==7 || M_old(l,12)==9
                m=m+1;
                if l<A
                    size2(l:A-m,:)=size2(l+1:A-m+1,:);
                end
            end
        end
        n=0;
        for k=1:A
            if remember_rectangular2(k)==0 && remember_square2(k)==0
                n=n+1;
                j=1+floor(rand*(A-m-n+1));
                M(k,14)=size2(j,1);
                size2_old=size2;
                size2(1:j-1,:)=size2_old(1:j-1,:);
                size2(j:A-m-n,:)=size2_old(j+1:A-m-n+1,:);
            end
        end
        
        structure(:,1)=M_old(:,18);
        structure(:,2)=[1:A];
        remember_brickfaced=zeros(A,1);
        for k=1:A
            j=1+floor(rand*(A-k+1));
            l=structure(j,2);
            if M_old(l,18)==1
                remember_brickfaced(k)=l;
            end
            M(k,18)=structure(j,1);
            structure_old=structure;
            structure(1:j-1,:)=structure_old(1:j-1,:);
            structure(j:A-k,:)=structure_old(j+1:A-k+1,:);
        end
        
        binding(:,1)=M_old(:,19);
        binding(:,2)=[1:A];
        for k=1:A
            if remember_brickfaced(k)>0
                j=remember_brickfaced(k);
                M(k,19)=M_old(j,19);
            end
        end
        m=0;
        for l=A:-1:1
            if M_old(l,18)==1
                m=m+1;
                if l<A
                    binding(l:A-m,:)=binding(l+1:A-m+1,:);
                end
            end
        end
        n=0;
        for k=1:A
            if remember_brickfaced(k)==0
                n=n+1;
                j=1+floor(rand*(A-m-n+1));
                M(k,19)=binding(j,1);
                binding_old=binding;
                binding(1:j-1,:)=binding_old(1:j-1,:);
                binding(j:A-m-n,:)=binding_old(j+1:A-m-n+1,:);
            end
        end
        
        rpos=M(:,3:4);
    for k=1:A
        j=1+floor(rand*(A-k+1));
        M(k,3:4)=rpos(j,:);
        rpos_old=rpos;
        rpos(1:j-1,:)=rpos_old(1:j-1,:);
        rpos(j:A-k,:)=rpos_old(j+1:A-k+1,:);
    end
        
        for i=9:10
            column=M_old(:,i);
            for k=1:A
                j=1+floor(rand*(A-k+1));
                M(k,i)=column(j);
                column_old=column;
                column(1:j-1,:)=column_old(1:j-1,:);
                column(j:A-k,:)=column_old(j+1:A-k+1,:);
            end
        end
        
        column=M_old(:,15);
        for k=1:A
            j=1+floor(rand*(A-k+1));
            M(k,15)=column(j);
            column_old=column;
            column(1:j-1,:)=column_old(1:j-1,:);
            column(j:A-k,:)=column_old(j+1:A-k+1,:);
        end
        
        for i=20:22
            column=M_old(:,i);
            for k=1:A
                j=1+floor(rand*(A-k+1));
                M(k,i)=column(j);
                column_old=column;
                column(1:j-1,:)=column_old(1:j-1,:);
                column(j:A-k,:)=column_old(j+1:A-k+1,:);
            end
        end
        
        column=M_old(:,23:24);
        for k=1:A
            j=1+floor(rand*(A-k+1));
            M(k,23:24)=column(j,:);
            column_old=column;
            column(1:j-1,:)=column_old(1:j-1,:);
            column(j:A-k,:)=column_old(j+1:A-k+1,:);
        end
        
        
    %----------------------------------------------------------------------
    %Now that the random database is created - let us analyze its structure
    %----------------------------------------------------------------------
    
    disregard=zeros(1,B-5);
    D_max=0;
    dphase_max=0;
    dphase_val=0;
    W=0;
        
    Dist=zeros(A,A);
    N=zeros(A,A);
    TN=zeros(A,A);
    PN=zeros(A,A);
    TWN=zeros(A,A);
    CN=zeros(A,A);
    dphase=zeros(A,A);
    dphase_eq=zeros(A,A);
    x_component=zeros(A,A);
    y_component=zeros(A,A);
    trueangle=zeros(A,A);
    
    TP=M(:,6)+(M(:,5)-M(:,6))/2;
    for j=1:A
        if TP(j)==175.5;
            TP(j)=-1;
        end
    end

    for j=1:A
        for k=1:j-1
            m=0;
            if ((M(j,5)>=M(k,5)&&M(j,6)<=M(k,5))||(M(j,5)>=M(k,6)&&M(j,6)<=M(k,6)))&&M(j,5)>-1&&M(k,5)>-1
                TN(j,k)=1;
                D(1)=0;
            else
                D(1)=1;
            end
            if ((TP(j)+W>=TP(k)+W&&TP(j)-W<=TP(k)+W)||(TP(j)+W>=TP(k)-W&&TP(j)-W<=TP(k)-W))&&TP(j)>-1&&TP(k)>-1
                TWN(j,k)=1;
            end
        
            D(2:B-7)=M(j,7:B-2)-M(k,7:B-2);
            
            if M(j,24)>=M(k,23) && M(j,23)<=M(k,24) && M(j,23)>-1 && M(k,23)>-1
                PN(j,k)=1;
                D(B-6)=0;
            else
                D(B-6)=1;
            end
            
            for l=1:B-6
                if D(l)+disregard(l)==0 && M(j,l+5)>-1 && M(k,l+5)>-1
                    m=m+1;
                end
            end
            CN(j,k)=m;
            %--------------------------------------------------------------
            %Correction for those variables for which two different values
            %are allowed in a given context (function, size category and
            %shape).
            %--------------------------------------------------------------
            if ((M(j,11)==M(k,12) && M(j,11)>-1) || (M(j,12)==M(k,11) && M(j,12)>-1)) && M(j,11)~=M(k,11) && M(j,12)~=M(k,12)
                CN(j,k)=m+1;
            end
            if M(j,11)==M(k,11) && M(j,12)==M(k,12) && M(j,11)>-1 && M(j,12)>-1
                CN(j,k)=m-1;
            end
            if ((M(j,13)==M(k,14) && M(j,13)>-1) || (M(j,14)==M(k,13) && M(j,14)>-1)) && M(j,13)~=M(k,13) && M(j,14)~=M(k,14)
                CN(j,k)=m+1;
            end
            if M(j,13)==M(k,13) && M(j,14)==M(k,14) && M(j,13)>-1 && M(j,14)>-1
                CN(j,k)=m-1;
            end
            if ((M(j,16)==M(k,17) && M(j,16)>-1) || (M(j,17)==M(k,16) && M(j,17)>-1)) && M(j,16)~=M(k,16) && M(j,17)~=M(k,17)
                CN(j,k)=m+1;
            end
            if M(j,16)==M(k,16) && M(j,17)==M(k,17) && M(j,16)>-1 && M(j,17)>-1
                CN(j,k)=m-1;
            end
        
            if abs(M(j,7)-M(k,7))<=dphase_max && M(j,7)>-1 && M(k,7)>-1
                dphase(j,k)=1;
            end
            
            if abs(M(j,7)-M(k,7))==dphase_val && M(j,7)>-1 && M(k,7)>-1
                dphase_eq(j,k)=1;
                if (M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2>1000
                    trueangle(j,k)=1;
                    if M(j,7)>M(k,7)
                        x_component(j,k)=M(k,3)-M(j,3);
                        y_component(j,k)=M(k,4)-M(j,4);
                    else
                        x_component(j,k)=M(j,3)-M(k,3);
                        y_component(j,k)=M(j,4)-M(k,4);
                    end
                end
            end
            
            if sqrt((M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2)<1000*D_max
                Dist(j,k)=1;
            end
        end
    end

    %----------------------------------------------------------------------
    %Contexts j and k are connected according to the instruction-string ss
    %----------------------------------------------------------------------
    for j=1:A
        for k=1:j-1
            if TN(j,k)==1&&(CN(j,k)>=CO)
                N(j,k)=1;
            end
        end
    end
    
    network_properties
    
    size(q)=sum(sum(N));
    if size(q)>size_true
        extreme_size=extreme_size+1;
    end
    p_size(q)=extreme_size/q;
    
    firstcomp(q)=component_dist(1);
    if firstcomp(q)>firstcomp_true
        extreme_firstcomp=extreme_firstcomp+1;
    end
    p_firstcomp(q)=extreme_firstcomp/q;
    
    if length(component_dist)>1
        secondcomp(q)=component_dist(2);
    else
        secondcomp(q)=0;
    end
    if secondcomp(q)>secondcomp_true
        extreme_secondcomp=extreme_secondcomp+1;
    end
    p_secondcomp(q)=extreme_secondcomp/q;
    
    numbercomp(q)=component_number;
    if numbercomp(q)>numbercomp_true
        extreme_numbercomp=extreme_numbercomp+1;
    end
    p_numbercomp(q)=extreme_numbercomp/q;
    
    meandegree(q)=Mean_degree;
    if meandegree(q)>meandegree_true
        extreme_meandegree=extreme_meandegree+1;
    end
    p_meandegree(q)=extreme_meandegree/q;
    
    vardegree(q)=Std_degree;
    if vardegree(q)>vardegree_true
        extreme_vardegree=extreme_vardegree+1;
    end
    p_vardegree(q)=extreme_vardegree/q;
    
    maxdegree(q)=Max_degree;
    if maxdegree(q)>maxdegree_true
        extreme_maxdegree=extreme_maxdegree+1;
    end
    p_maxdegree(q)=extreme_maxdegree/q;
    
    diameter(q)=Diameter;
    if diameter(q)>diameter_true
        extreme_diameter=extreme_diameter+1;
    end
    p_diameter(q)=extreme_diameter/q;
    
    pathlength(q)=mean_path_length;
    if pathlength(q)>pathlength_true
        extreme_pathlength=extreme_pathlength+1;
    end
    p_pathlength(q)=extreme_pathlength/q;
    
    clustering(q)=CG;
    if clustering(q)>clustering_true
        extreme_clustering=extreme_clustering+1;
    end
    p_clustering(q)=extreme_clustering/q;
   
end

sorted_size=sort(size);
mean_size(CO)=sum(size)/q_max;
save mean_size2 mean_size
significance_size(CO)=p_size(q_max);
save significance_size2 significance_size
significant_large_size(CO)=sorted_size(ceil(0.95*q_max));
save significant_large_size2 significant_large_size
significant_small_size(CO)=sorted_size(ceil(0.05*q_max));
save significant_small_size2 significant_small_size

%--------------------------------------------------------------------------

sorted_clustering=sort(clustering);
mean_clustering(CO)=sum(clustering)/q_max;
save mean_clustering2 mean_clustering
significance_clustering(CO)=p_clustering(q_max);
save significance_clustering2 significance_clustering
significant_large_clustering(CO)=sorted_clustering(ceil(0.95*q_max));
save significant_large_clustering2 significant_large_clustering
significant_small_clustering(CO)=sorted_clustering(ceil(0.05*q_max));
save significant_small_clustering2 significant_small_clustering

%--------------------------------------------------------------------------

sorted_pathlength=sort(pathlength);
mean_pathlength(CO)=sum(pathlength)/q_max;
save mean_pathlength2 mean_pathlength
significance_pathlength(CO)=p_pathlength(q_max);
save significance_pathlength2 significance_pathlength
significant_large_pathlength(CO)=sorted_pathlength(ceil(0.95*q_max));
save significant_large_pathlength2 significant_large_pathlength
significant_small_pathlength(CO)=sorted_pathlength(ceil(0.05*q_max));
save significant_small_pathlength2 significant_small_pathlength

sorted_diameter=sort(diameter);
mean_diameter(CO)=sum(diameter)/q_max;
save mean_diameter2 mean_diameter
significant_large_diameter(CO)=sorted_diameter(ceil(0.95*q_max));
save significant_large_diameter2 significant_large_diameter
significant_small_diameter(CO)=sorted_diameter(ceil(0.05*q_max));
save significant_small_diameter2 significant_small_diameter
significance_diameter(CO)=p_diameter(q_max);
save significance_diameter2 significance_diameter

%--------------------------------------------------------------------------

sorted_maxdegree=sort(maxdegree);
mean_maxdegree(CO)=sum(maxdegree)/q_max;
save mean_maxdegree2 mean_maxdegree
significance_maxdegree(CO)=p_maxdegree(q_max);
save significance_maxdegree2 significance_maxdegree
significant_large_maxdegree(CO)=sorted_maxdegree(ceil(0.95*q_max));
save significant_large_maxdegree2 significant_large_maxdegree
significant_small_maxdegree(CO)=sorted_maxdegree(ceil(0.05*q_max));
save significant_small_maxdegree2 significant_small_maxdegree

sorted_meandegree=sort(meandegree);
mean_meandegree(CO)=sum(meandegree)/q_max;
save mean_meandegree2 mean_meandegree
significance_meandegree(CO)=p_meandegree(q_max);
save significance_meandegree2 significance_meandegree
significant_large_meandegree(CO)=sorted_meandegree(ceil(0.95*q_max));
save significant_large_meandegree2 significant_large_meandegree
significant_small_meandegree(CO)=sorted_meandegree(ceil(0.05*q_max));
save significant_small_meandegree2 significant_small_meandegree

sorted_vardegree=sort(vardegree);
mean_vardegree(CO)=sum(vardegree)/q_max;
save mean_vardegree2 mean_vardegree
significance_vardegree(CO)=p_vardegree(q_max);
save significance_vardegree2 significance_vardegree
significant_large_vardegree(CO)=sorted_vardegree(ceil(0.95*q_max));
save significant_large_vardegree2 significant_large_vardegree
significant_small_vardegree(CO)=sorted_vardegree(ceil(0.05*q_max));
save significant_small_vardegree2 significant_small_vardegree

%--------------------------------------------------------------------------

sorted_firstcomp=sort(firstcomp);
mean_firstcomp(CO)=sum(firstcomp)/q_max;
save mean_firstcomp2 mean_firstcomp
significance_firstcomp(CO)=p_firstcomp(q_max);
save significance_firstcomp2 significance_firstcomp
significant_large_firstcomp(CO)=sorted_firstcomp(ceil(0.95*q_max));
save significant_large_firstcomp2 significant_large_firstcomp
significant_small_firstcomp(CO)=sorted_firstcomp(ceil(0.05*q_max));
save significant_small_firstcomp2 significant_small_firstcomp

sorted_secondcomp=sort(secondcomp);
mean_secondcomp(CO)=sum(secondcomp)/q_max;
save mean_secondcomp2 mean_secondcomp
significance_secondcomp(CO)=p_secondcomp(q_max);
save significance_secondcomp2 significance_secondcomp
significant_large_secondcomp(CO)=sorted_secondcomp(ceil(0.95*q_max));
save significant_large_secondcomp2 significant_large_secondcomp
significant_small_secondcomp(CO)=sorted_secondcomp(ceil(0.05*q_max));
save significant_small_secondcomp2 significant_small_secondcomp

sorted_numbercomp=sort(numbercomp);
mean_numbercomp(CO)=sum(numbercomp)/q_max;
save mean_numbercomp2 mean_numbercomp
significance_numbercomp(CO)=p_numbercomp(q_max);
save significance_numbercomp2 significance_numbercomp
significant_large_numbercomp(CO)=sorted_numbercomp(ceil(0.95*q_max));
save significant_large_numbercomp2 significant_large_numbercomp
significant_small_numbercomp(CO)=sorted_numbercomp(ceil(0.05*q_max));
save significant_small_numbercomp2 significant_small_numbercomp

end

M=M_old;