%--------------------------------------------------------------------------
%For do_edgelenghts=1, the program calculates the median edgelengths
%"random_edgelength" for q_max trials where the contexts are randomly
%distributed on the given sites. The ratio of the random median edglengths
%that are shorter than the true median edge length "elength" (given by the
%program direction_lengths.m) is stored in the vector "significance". The
%same choice as to whether zero edge lengths shall be included as in that
%program should be made here (see line 234). The contexts may be randomly
%distributed in three different ways, corresponding to mix_all=1,2 or 3.
%
%If do_directions=1, the program calculates the length "random_vlength" of
%the resultant diffusion vector (x,y) for q_max trials where the contexts
%are randomly distributed on the sites according to the above. The ratio
%"significance" of the random vector lengths that are shorter than the true
%vector length (given by direction_length.m) is stored. Preferably, set
%mix_all=0.
%
%NOTE: use the same network instruction as in the true network used in
%direction_lengths.m (line 220).
%--------------------------------------------------------------------------


clear significance
clear random_vlength

Matrix_truepositions
sites
descriptions

% Questionable contexts are excluded in the final data_base matrix M, and
% has to be erased from the matrix M_raw read from the file M_test2.m.
%--------------------------------------------------------------------------
A_raw=length(M_raw(:,1));
j=0;
for k=1:A_raw
    if M_raw(k,2)==0
        j=j+1;
        M(j,:)=M_raw(k,:);
        site_names(j)=site_names_raw(k);
        Descriptions(j)=Descriptions_raw(k);
    end
end
A=length(M(:,1));
B=length(M(1,:))-1;

N=zeros(A,A);

site_pos
M_old=M;

q_max=3000;

T_old1=225;
T_new1=125;
T_old2=125;
T_new2=25;

%vlength=0.3464;

extreme_d=0;
for q=1:q_max
    q
    
    spos=site_positions(:,2:3);
    LSP=length(site_positions);
    for k=1:LSP
        j=1+floor(rand*(LSP-k+1));
        for m=1:A
            if M(m,25)==k
                M(m,3:4)=spos(j,:);
            end
        end
        spos_old=spos;
        spos(1:j-1,:)=spos_old(1:j-1,:);
        spos(j:LSP-k,:)=spos_old(j+1:LSP-k+1,:);
    end
            
    count=0;
    x=0;
    y=0;
    for j=1:A
        for k=1:A
            if (M(j,7)<=T_old1 & M(j,7)>=T_new1) && (M(k,7)<=T_old2 & M(k,7)>=T_new2)
                if (M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2>1000
                    count=count+1;
                    x_component=M(k,3)-M(j,3);
                    y_component=M(k,4)-M(j,4);
                    vl=sqrt(x_component^2+y_component^2);
                    vx=x_component/vl;
                    vy=y_component/vl;
                    x=x+vx;
                    y=y+vy;
                end
            end
        end
    end

    random_vlength(q)=sqrt(x^2+y^2)/count;
        
    if random_vlength(q)>vlength
        extreme_d=extreme_d+1;
    end
    significance(q)=extreme_d/q;

    

end
%M=M_old;

sorted_vlengths=sort(random_vlength);
L=length(sorted_vlengths);
if mod(L,2)==0
    median_vlength=(sorted_vlengths(L/2)+sorted_vlengths(L/2+1))/2;
else
    median_vlength=sorted_vlengths(floor(L/2)+1);
 end
median_vlength
significant_r=sorted_vlengths(ceil(0.95*L))
signifikans=significance(q_max)


