%--------------------------------------------------------------------------
%For do_edgelenghts=1, the program calculates the median edgelengths
%"random_edgelength" for q_max trials where the contexts are randomly
%distributed on the given sites. The ratio of the random median edglengths
%that are shorter than the true median edge length "elength" (given by the
%program direction_lengths.m) is stored in the vector "significance". The
%same choice as to whether zero edge lengths shall be included as in that
%program should be made here (see line 234). The contexts may be randomly
%distributed in three different ways, corresponding to mix_all=1,2 or 3.
%
%If do_directions=1, the program calculates the length "random_vlength" of
%the resultant diffusion vector (x,y) for q_max trials where the contexts
%are randomly distributed on the sites according to the above. The ratio
%"significance" of the random vector lengths that are shorter than the true
%vector length (given by direction_length.m) is stored. Preferably, set
%mix_all=0.
%
%NOTE: use the same network instruction as in the true network used in
%direction_lengths.m (line 220).
%--------------------------------------------------------------------------


clear significance
clear random_vlength
clear random_elength

Matrix_truepositions
sites
descriptions

% Questionable contexts are excluded in the final data_base matrix M, and
% has to be erased from the matrix M_raw read from the file M_test2.m.
%--------------------------------------------------------------------------
A_raw=length(M_raw(:,1));
j=0;
for k=1:A_raw
    %if M_raw(k,2)==0
    if M_raw(k,2)==0 && M_raw(k,8)==3
        j=j+1;
        M(j,:)=M_raw(k,:);
        site_names(j)=site_names_raw(k);
        Descriptions(j)=Descriptions_raw(k);
    end
end
A=length(M(:,1));
B=length(M(1,:))-1;

site_pos
M_old=M;
do_directions=0;
do_edgelengths=1;
mix_all=0;
dphase_val=25;
W=0;
q_max=5000;
T_old=100;
T_new=50;
CO=1;
vlength=0.2047;
elength=488576;

extreme_l=0;
extreme_d=0;
histogram=0;
for q=1:q_max
    q
    clear RTN
    M=M_old;
    RTN=zeros(A,A);
    
    %----------------------------------------------------------------------
    %If mix_all=0, a random database is created where all contexts located
    %at a given site are moved together to another random site
    %----------------------------------------------------------------------
    if mix_all==0
        clear spos
        site_numbers=sort(M(:,25));
        spos(1,:)=site_positions(site_numbers(1),2:3);
        j=1;
        for k=2:A
            if site_numbers(k)~=site_numbers(k-1)
                j=j+1;
                spos(j,:)=site_positions(site_numbers(k),2:3);
            end
        end   
        LSP=length(spos);
        %spos=site_positions(:,2:3);
        %LSP=length(site_positions);
        for k=1:LSP
            j=1+floor(rand*(LSP-k+1));
            for m=1:A
                if M(m,25)==k
                    M(m,3:4)=spos(j,:);
                end
            end
            spos_old=spos;
            spos(1:j-1,:)=spos_old(1:j-1,:);
            spos(j:LSP-k,:)=spos_old(j+1:LSP-k+1,:);
        end
    end
            
    %----------------------------------------------------------------------
    %If mix_all=1, a random database is created where each context is moved
    %to a new random site. Thus two contexts that originally belong to the
    %same site may happen to be placed at different sites
    %----------------------------------------------------------------------
    if mix_all==1
        rpos=M(:,3:4);
        for k=1:A
            j=1+floor(rand*(A-k+1));
            M(k,3:4)=rpos(j,:);
            rpos_old=rpos;
            rpos(1:j-1,:)=rpos_old(1:j-1,:);
            rpos(j:A-k,:)=rpos_old(j+1:A-k+1,:);
        end
    end
    
    %----------------------------------------------------------------------
    %Like mix_all=1, but new random sites that are assigned can be assigned
    %again.
    %----------------------------------------------------------------------
    if mix_all==2
        rpos=M(:,3:4);
        for k=1:A
            j=1+floor(rand*A);
            M(k,3:4)=rpos(j,:);
        end
    end
    
    Dist=zeros(A,A);
    N=zeros(A,A);
    TN=zeros(A,A);
    PN=zeros(A,A);
    TWN=zeros(A,A);
    CN=zeros(A,A);
    dphase=zeros(A,A);
    dphase_eq=zeros(A,A);
    x_component=zeros(A,A);
    y_component=zeros(A,A);
    trueangle=zeros(A,A);
    
    TP=M(:,6)+(M(:,5)-M(:,6))/2;
    for j=1:A
        if TP(j)==175.5;
            TP(j)=-1;
        end
    end

    for j=1:A
        for k=1:j-1
            m=0;
            if ((M(j,5)>=M(k,5)&&M(j,6)<=M(k,5))||(M(j,5)>=M(k,6)&&M(j,6)<=M(k,6)))&&M(j,5)>-1&&M(k,5)>-1
                TN(j,k)=1;
                D(1)=0;
            else
                D(1)=1;
            end
            if ((TP(j)+W>=TP(k)+W&&TP(j)-W<=TP(k)+W)||(TP(j)+W>=TP(k)-W&&TP(j)-W<=TP(k)-W))&&TP(j)>-1&&TP(k)>-1
                TWN(j,k)=1;
            end
        
            D(2:B-7)=M(j,7:B-2)-M(k,7:B-2);
            
            if M(j,24)>=M(k,23) && M(j,23)<=M(k,24) && M(j,23)>-1 && M(k,23)>-1
                PN(j,k)=1;
                D(B-6)=0;
            else
                D(B-6)=1;
            end
            
            for l=1:B-6
                if D(l)+disregard(l)==0 && M(j,l+5)>-1 && M(k,l+5)>-1
                    m=m+1;
                end
            end
            CN(j,k)=m;
            %--------------------------------------------------------------
            %Correction for those variables for which two different values
            %are allowed in a given context (function, size category and
            %shape).
            %--------------------------------------------------------------
            if ((M(j,11)==M(k,12) && M(j,11)>-1) || (M(j,12)==M(k,11) && M(j,12)>-1)) && M(j,11)~=M(k,11) && M(j,12)~=M(k,12)
                CN(j,k)=m+1;
            end
            if M(j,11)==M(k,11) && M(j,12)==M(k,12) && M(j,11)>-1 && M(j,12)>-1
                CN(j,k)=m-1;
            end
            if ((M(j,13)==M(k,14) && M(j,13)>-1) || (M(j,14)==M(k,13) && M(j,14)>-1)) && M(j,13)~=M(k,13) && M(j,14)~=M(k,14)
                CN(j,k)=m+1;
            end
            if M(j,13)==M(k,13) && M(j,14)==M(k,14) && M(j,13)>-1 && M(j,14)>-1
                CN(j,k)=m-1;
            end
            if ((M(j,16)==M(k,17) && M(j,16)>-1) || (M(j,17)==M(k,16) && M(j,17)>-1)) && M(j,16)~=M(k,16) && M(j,17)~=M(k,17)
                CN(j,k)=m+1;
            end
            if M(j,16)==M(k,16) && M(j,17)==M(k,17) && M(j,16)>-1 && M(j,17)>-1
                CN(j,k)=m-1;
            end
        
            if abs(M(j,7)-M(k,7))<=dphase_max && M(j,7)>-1 && M(k,7)>-1
                dphase(j,k)=1;
            end
            
            if abs(M(j,7)-M(k,7))==dphase_val && M(j,7)>-1 && M(k,7)>-1
                dphase_eq(j,k)=1;
                if (M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2>1000
                    trueangle(j,k)=1;
                    if M(j,7)>M(k,7)
                        x_component(j,k)=M(k,3)-M(j,3);
                        y_component(j,k)=M(k,4)-M(j,4);
                    else
                        x_component(j,k)=M(j,3)-M(k,3);
                        y_component(j,k)=M(j,4)-M(k,4);
                    end
                end
            end
            
            if sqrt((M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2)<1000*D_max
                Dist(j,k)=1;
            end
        end
    end

    %----------------------------------------------------------------------
    %Contexts j and k are connected according to the instruction-string ss
    %----------------------------------------------------------------------
    for j=1:A
        for k=1:j-1
            %Insert the same network instruction below as in the true
            %network used in the program direction_lengths.m
            if TN(j,k)==1&&(CN(j,k)>=CO)
                N(j,k)=1;
            end
        end
    end
    
    if do_directions==1
        x=0;
        y=0;
        count=0;
        for j=1:A
            for k=1:A
                if trueangle(j,k)==1 && N(j,k)==1
                    count=count+1;
                    vl=sqrt(x_component(j,k)^2+y_component(j,k)^2);
                    vx=x_component(j,k)/vl;
                    vy=y_component(j,k)/vl;
                    x=x+vx;
                    y=y+vy;
                end
            end
        end
        random_vlength(q)=sqrt(x^2+y^2)/count;
        
        if random_vlength(q)>vlength
            extreme_d=extreme_d+1;
        end
        significance(q)=extreme_d/q;
    end
    
    if do_edgelengths==1
    
        clear edgelengths
        clear sorted_lengths
      
        count=0;
        for j=1:A
            for k=1:j-1
                %Choose whether to exclude zero edge lengths (the following
                %if-sentence) or not (the second following if-sentence).
                if N(j,k)==1 && sqrt((M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2)>0
                %if N(j,k)==1
                    count=count+1;
                    edgelengths(count)=sqrt((M(j,3)-M(k,3))^2+(M(j,4)-M(k,4))^2);
                end
            end
        end
        histogram=histogram+hist(edgelengths,[0:40000:5000000]);
        sorted_lengths=sort(edgelengths);
        L=length(sorted_lengths);
        if mod(L,2)==0
            random_elength(q)=(sorted_lengths(L/2)+sorted_lengths(L/2+1))/2;
        else
            random_elength(q)=sorted_lengths(floor(L/2)+1);
        end
        
        if random_elength(q)<elength
            extreme_l=extreme_l+1;
        end
        significance(q)=extreme_l/q;
        
    end
    

end
%M=M_old;

if do_directions==1
    sorted_vlengths=sort(random_vlength);
    L=length(sorted_vlengths);
    if mod(L,2)==0
        median_vlength=(sorted_vlengths(L/2)+sorted_vlengths(L/2+1))/2;
    else
        median_vlength=sorted_vlengths(floor(L/2)+1);
    end
    median_vlength
    significant_r=sorted_vlengths(ceil(0.95*L))
    signifikans=significance(q_max)
end

if do_edgelengths==1
    rl=sum(random_elength)/q_max
    sl=sort(random_elength);
    pl1=sl(ceil(0.05*q_max))
    pl2=sl(ceil(0.95*q_max))
end
