    %----------------------------------------------------------------------
    %Identification of network components and calculation of their size
    %distribution.
    %----------------------------------------------------------------------
    
    components=zeros(A,3);
    component_nr=1;
    components(1,1)=component_nr;
    for j=2:A
        match=0;
        for k=1:j-1
            if N(j,k)==1 && match==0
                components(j,1)=components(k,1);
                match=1;
            end
            if N(j,k)==1 && match==1
                old_nr=components(k,1);
                for l=1:j-1
                    if components(l,1)==old_nr
                        components(l,1)=components(j,1);
                    end
                end
            end
        end
        if match==0
            component_nr=component_nr+1;
            components(j,1)=component_nr;
        end
    end
    component_sizes=zeros(A,1);
    for j=1:component_nr
        for k=1:A
            if components(k,1)==j
                component_sizes(j)=component_sizes(j)+1;
            end
        end
        for k=1:A
            if components(k,1)==j
                components(k,2)=component_sizes(j);
            end
        end
    end
                 
    component_sizes=sort(component_sizes,'descend');
    k=1;
    while component_sizes(k)>1
        k=k+1;
    end
    component_dist=component_sizes(1:k);
    component_number=k-1;
    if k>1
        solis=A-sum(component_dist(1:k-1));
    else
        solis=A;
    end
            
   
    size_list=components(:,2);
    size_nr=1;
    while max(size_list)>0
        [i j]=max(size_list);
        for k=1:A
            if components(k,1)==components(j,1)
                components(k,3)=size_nr;
                size_list(k)=0;
            end
        end
        size_nr=size_nr+1;
    end
    
    %----------------------------------------------------------------------
    %Calculation of the clustering coefficient
    %----------------------------------------------------------------------

    
    n_triangles=0;
    n_triplets=0;
    l=0;
    NN=N;
    for j=1:A
        for k=1:j-1
            NN(k,j)=N(j,k);
        end
    end
    for j=1:A
        neighbor=0;
        L=sum(NN(j,:));
        if L>1
            m=0;
            for k=1:A
                if NN(j,k)==1
                    m=m+1;
                    neighbor(m)=k;
                end
            end
            c=0;
            for k=1:L
                for m=k+1:L
                    if NN(neighbor(m),neighbor(k))==1
                        n_triplets=n_triplets+1;
                        n_triangles=n_triangles+1;
                    else
                        n_triplets=n_triplets+1;
                    end
                end
            end
            l=l+1;
        end             
    end
    if l>0
        CG=n_triangles/n_triplets;
    else
        CG=0;
    end
    
    %CR=2*length(edges)/(A*(A-1));
    
    %----------------------------------------------------------------------
    %Degree distribution
    %----------------------------------------------------------------------
    clear degree
    clear H
    clear IH
    no_dist=0;
    l=0;
    for k=1:A
        if sum(N(k,:))+sum(N(:,k))>0
            l=l+1;
            degree(l)=sum(N(k,:))+sum(N(:,k));
        end
    end
    if l>0
        Mean_degree=sum(degree)/l;
    else
        Mean_degree=0;
        degree=0;
    end
    if l>1
        Std_degree=sqrt(sum((degree-Mean_degree).^2)/(l-1));
    else
        Std_degree=0;
    end
    Max_degree=max(degree);
    if max(degree)>1
        H=hist(degree,[1:1:max(degree)]);
        for k=1:max(degree)
            IH(k)=sum(H(k:max(degree)));
        end
    else
        no_dist=1;
    end
    

    %----------------------------------------------------------------------
    %Path lengths
    %----------------------------------------------------------------------
    SN=sparse(N);
    for k=1:A
        [Distances(k,:),path,pred]=graphshortestpath(SN,k,'method','BFS','directed','false');
    end
    D_zero=Distances;
    l=0;
    for j=1:A
        for k=1:A
            if Distances(j,k)==inf
                D_zero(j,k)=0;
                l=l+1;
            end
        end
    end
    Diameter=max(max(D_zero));
    if A*(A-1)-l>0
        mean_path_length=sum(sum(D_zero))/(A*(A-1)-l);
    else
        mean_path_length=0;
    end
  