figure(res_fig)

axes(component_axes)
cla
set(component_axes,'visible','on')
bar(component_dist)
xlabel('Component number')
ylabel('Component size')
title('Component size distribution')

set(r3t,'visible','on')
r3=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.75 0.64 0.2 0.03],'backgroundc','w','string',num2str(CG),'fonts',10);
    
set(r7t,'visible','on')
r7=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.75 0.61 0.2 0.03],'backgroundc','w','string',num2str(mean_path_length),'fonts',10);
    
set(r8t,'visible','on')
r8=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.75 0.58 0.2 0.03],'backgroundc','w','string',num2str(Diameter),'fonts',10);
    
if no_dist==0    
    axes(degree_axes)
    cla
    set(degree_axes,'visible','on')
    bar([1:1:max(degree)],H)
    axis([0 max(degree)+1 0 max(H)+1])
    xlabel('Degree')
    ylabel('Number of nodes')
    title('Degree distribution F')

else
    set(degree_axes,'visible','off')
end


axes(edge_axes)
cla
set(edge_axes,'visible','on')
x=edgebin_length*[1:LLL]/1000;
loglog(x,cad,'ko')
a=get(edge_axes,'ylim');
%axis([0 4000 0.05 10])
%axis([0 2000 a(1) a(2)])
xlabel('Edge length (km)')
title('Cumulative edge realization ratio')
